"""File utilities for semvergit."""

from loguru import logger
from semver import VersionInfo


def update_verion_file(version_file: str, new_version: VersionInfo, dry_run: bool) -> None:
    """Update version file."""
    file_content = [
        '"""Version of the package - This file is generated by semvergit"""',
        "",
        f'__version__ = "{new_version}"\n',
    ]

    version_file_content = "\n".join(file_content)

    if dry_run:
        logger.debug(f"Dry run, version file content:\n{version_file_content}")
    else:
        with open(version_file, "w", encoding="utf-8") as version_file_handle:
            version_file_handle.write(version_file_content)
